/////////////////////////////////////////////////////
//DeathMatchPlus original expanded for monsters usage
//The mostly is addressing for NsMonster or
//closer not others involving replications
//and different retarded ideas
/////////////////////////////////////////////////////
class DeathMatchPlus extends BotPack.DeathMatchPlus;
// directly in subject
var Actor CaptActor;

event PreBeginPlay()
{
//	SetGameSpeed(GameSpeed); //Removed
	Level.bNoCheating = bNoCheating;
	Level.bAllowFOV = bAllowFOV;

	if (GameReplicationInfoClass != None)
		GameReplicationInfo = Spawn(GameReplicationInfoClass);
	else
		GameReplicationInfo = Spawn(class'GameReplicationInfo');
	InitGameReplicationInfo();
}

function SetGameSpeed( Float T )
{
	local float InitialSpeed;

	GameSpeed = FMax(T,0.1);
	InitialSpeed = GameSpeed;
	SaveConfig();
	GameSpeed = FMax(T*1.050000,0.1); //Screw crappy mapping
	Level.TimeDilation = GameSpeed; //almost timing
	Log ("GameSpeed has been set: "$GameSpeed);
	Log ("TimeDilation is: "$Level.TimeDilation);
	SetTimer(Level.TimeDilation, true);
	GameSpeed = InitialSpeed;
}

event PostBeginPlay()
{
	local CaptureActor Ac;

	foreach Level.AllActors (class 'CaptureActor',Ac)
	{
		if ( Ac != None )
		{
			CaptActor = Ac;
			log ("Game Core found CaptureActor.");
			break;
		}
	}
	Super.PostBeginPlay();
}

function PreCacheReferences()
{
	//never called - here to force precaching of meshes like in any normal UT game...
	//continuing mission in attempt to reduce lag as much as possible
	Spawn(Class'UnrealShare.BruteCarcass');
	Spawn(Class'UnrealShare.LesserBruteCarcass');
	Spawn(Class'UnrealShare.CowCarcass');
	Spawn(Class'UnrealShare.DevilfishCarcass');
	Spawn(Class'UnrealShare.FlyCarcass');
	Spawn(Class'UnrealI.GassiusCarcass');
	Spawn(Class'UnrealI.KrallCarcass');
	Spawn(Class'UnrealShare.MantaCarcass');
	Spawn(Class'UnrealI.MercCarcass');
	Spawn(Class'UnrealShare.NaliCarcass');
	Spawn(Class'UnrealI.PupaeCarcass');
	Spawn(Class'UnrealShare.CreatureCarcass');
	Spawn(Class'UnrealShare.SkaarjCarcass');
	Spawn(Class'UnrealI.TrooperCarcass');
	Spawn(Class'UnrealShare.SlithCarcass');
	Spawn(Class'UnrealShare.TentacleCarcass');
	Spawn(Class'UnrealI.WarlordCarcass');
	Spawn(Class'Unrealshare.CreatureChunks');
	//Reinforce Defaults
	spawn(class'TMale1');
	spawn(class'TMale2');
	spawn(class'TFemale1');
	spawn(class'TFemale2');
	spawn(class'TBoss');
	spawn(class'ImpactHammer');
	spawn(class'Translocator');
	spawn(class'Enforcer');
	spawn(class'UT_Biorifle');
	spawn(class'ShockRifle');
	spawn(class'PulseGun');
	spawn(class'Ripper');
	spawn(class'Minigun2');
	spawn(class'UT_FlakCannon');
	spawn(class'UT_Eightball');
	spawn(class'SniperRifle');
	spawn(class'WarheadLauncher'); //This one too, fags !
	//Now Let's see the options for old weaponry
	//These are in fact meshes used - originals
	Spawn(class'UnrealShare.ASMD');
	Spawn(class'UnrealShare.AutoMag');
	Spawn(class'UnrealShare.DispersionPistol');
	Spawn(class'UnrealShare.Eightball');
	Spawn(class'UnrealI.FlakCannon');
	Spawn(class'UnrealI.GESBioRifle');
	Spawn(class'UnrealI.Minigun');
//	Spawn(class'UnrealI.QuadShot'); //Lol here - We get rid of this null shit anyway
	Spawn(class'UnrealI.Razorjack');
	Spawn(class'UnrealI.Rifle');
	Spawn(class'UnrealShare.Stinger');
}

function SolveWepsy()
{
	local Inventory I;
	local string Sc;

	foreach AllActors(class'Inventory',I)
	{
		if ( I != None )
		{
			if (I.bStatic)
			{
				log(I@"is wrong set bStatic...");
				Sc = Caps(I.Class);
				Sc = "set"@Sc@"bStatic 0";
				ConsoleCommand(Sc);
//				Sc = "set"@Sc@"bRotatingPickup 0";
//				ConsoleCommand(Sc);
				I.bRotatingPickup=False;
				log (I@"has now bStatic ="@I.bStatic);
				Sc = "";
			}
			if (I.bNoDelete)
			{
				log(I@"is wrong set bNoDelete...");
				Sc = Caps(I.Class);
				Sc = "set"@Sc@"bNoDelete 0";
				ConsoleCommand(Sc);
//				Sc = "set"@Sc@"bRotatingPickup 0";
//				ConsoleCommand(Sc);
				I.bRotatingPickup=False;
				log (I@"has now bNoDelete ="@I.bNoDelete);
				Sc = "";
			}
		}
	}
}

event InitGame( string Options, out string Error )
{
	local string InOpt;
	StartTime = 0;
	RemainingTime = 60 * TimeLimit;
	SetGameSpeed(GameSpeed);
	SolveWepsy();
	Super(GameInfo).InitGame(Options, Error);
	//DeathMatchPlus
	FragLimit = GetIntOption( Options, "FragLimit", FragLimit );
	TimeLimit = GetIntOption( Options, "TimeLimit", TimeLimit );
	MaxCommanders = GetIntOption( Options, "MaxCommanders", MaxCommanders );

	InOpt = ParseOption( Options, "CoopWeaponMode");
	if ( InOpt != "" )
	{
		log("CoopWeaponMode: "$bool(InOpt));
		bCoopWeaponMode = bool(InOpt);
	}

	IDnum = -1;
	IDnum = GetIntOption( Options, "Tournament", IDnum );
	if ( IDnum > 0 )
	{
		bRatedGame = true;
		TimeLimit = 0;
		RemainingTime = 0;
	}
	if ( bTournament ) 
	{
		bRequireReady = true;
		CheckReady();
	}
	if ( Level.NetMode == NM_StandAlone )
	{
		bRequireReady = true;
		CountDown = 1;
	}
	if ( !bRequireReady && (Level.NetMode != NM_Standalone) )
	{
		bRequireReady = true;
		bNetReady = true;
	}

	bNoMonsters = False;
	NetWait = 1.000000;
	RestartWait = 3.000000;
//	bRequireReady = False;
//	bNetReady = False;
	bWorldLog = False;
	//Craps removed, time to play
}

// Reworked
function Killed(pawn killer, pawn Other, name damageType)
{
	local int NextTaunt, i;
	local bool bAutoTaunt, bEndOverTime;
	local Pawn P, Best;
	local Projectile Pr;
	// Section: Turns Off bullshits
	foreach Other.RadiusActors ( class 'Projectile',Pr,Other.Default.SightRadius )
	{
		if ( Pr != None && Pr.Instigator == Other )		// I don't check for "Other" because that one called this function not "Killer"
		{
			Pr.bReplicateInstigator = False;
			Pr.Instigator = None;
			Pr.Destroy();
		}
	}
	// End of Bullshits Destruction

	if ( Killer != None && (!Killer.bIsPlayer || Killer.PlayerReplicationInfo == None ) && Other.PlayerReplicationInfo != None && Other.bIsPlayer )
	{
		Other.DieCount++;
		Other.PlayerReplicationInfo.Deaths += 1;
		Other.PlayerReplicationInfo.Score -= 1;
//		log (Other.GetHumanName()$" died having "$Other.PlayerReplicationInfo.Deaths);
	}
	if ( (damageType == 'Decapitated') && (Killer != Other) && (Killer != None) && Killer.PlayerReplicationInfo != None )
	{
		if ( Killer.bIsHuman ) //Bot need to receive this crap, dude ? I think Loque doesn't give a shit on this :|
			Killer.ReceiveLocalizedMessage( class'DecapitationMessage' );
	}
//Moved before to call super because GameInfo is not ready for monsters and won't be soon. Sleep well, UTPG ! :|
	if ( Killer != None)
	{
		if ( Killer.PlayerReplicationInfo != None && Killer != Other )
			Killer.PlayerReplicationInfo.Score += 1;
		if ( Other.Spree > 4 && Other.PlayerReplicationInfo != None )
		{
			if ( Killer.PlayerReplicationInfo != None )
				EndSpree(Killer, Other);
		}
		Other.Spree = 0;
		if ( !bFirstBlood )
			if ( Killer != Other && Killer.PlayerReplicationInfo != None )
				if (!Self.IsA('TrainingDM'))
				{
					BroadcastLocalizedMessage( class'FirstBloodMessage', 0, Killer.PlayerReplicationInfo );
				}
		if ( /*Other.bIsPlayer End of crap &&*/ (Killer != None) && (Killer != Other) && Killer.PlayerReplicationInfo != None )
		{
			Killer.Spree++;
			if ( Killer.Spree > 4 )
				NotifySpree(Killer, Killer.Spree);
		} 
		if ( Killer.IsA('ScriptedPawn') && Killer != Other )
			ScriptedPawn(Killer).WhatToDoNext('Roaming','Roam');
		if ( bRatedGame ) //hmmmm... 
			RateVs(Other, Killer); // Is returned if is out of normality so I think is not a problem
		bFirstBlood = True;
		if ( !bTeamGame )
		{
			if ( bOverTime )
			{
				bEndOverTime = true;
				//check for clear winner now
				// find individual winner
				for ( P=Level.PawnList; P!=None; P=P.nextPawn )
				{
					if ( P.PlayerReplicationInfo == None )
						continue;
					if ( P.PlayerReplicationInfo != None && ((Best == None) || (P.PlayerReplicationInfo.Score > Best.PlayerReplicationInfo.Score)) )
						Best = P;
				}
				// check for tie
				for ( P=Level.PawnList; P!=None; P=P.nextPawn )
				{
					if ( P.PlayerReplicationInfo == None )
						continue;
					if ( P.PlayerReplicationInfo != None && (Best != P) && (P.PlayerReplicationInfo.Score == Best.PlayerReplicationInfo.Score || Best.PlayerReplicationInfo.Score == 0) )
						bEndOverTime = False;
					if ( Best != None && Best.PlayerReplicationInfo != None && Best.PlayerReplicationInfo.Score != 0 )
						bEndOverTime = True;
				}
				if ( bEndOverTime )
				{
					if ( (FragLimit > 0) && (Best.PlayerReplicationInfo.Score >= FragLimit) && Best != None )
						EndGame("fraglimit");
					else
						EndGame("timelimit");
				}
			}
			else if ( (FragLimit > 0) && (killer != None) && (killer.PlayerReplicationInfo != None)
					&& (killer.PlayerReplicationInfo.Score >= FragLimit) )
				EndGame("fraglimit");
		}
	}
	else
	{
		// Completed because of new parameters and your laziness
		if ( !Other.bIsPlayer || Other.PlayerReplicationInfo == None )
		{
			if (DamageType == 'Exploded')
				BroadcastMessage(Other.GetHumanName()@" had a strange explosion.");
			else if (DamageType == 'Burned')
				BroadcastMessage(Other.GetHumanName()@" was burned by a hostile environment.");
			else if (DamageType == 'Corroded')
				BroadcastMessage(Other.GetHumanName()@" was corroded by a hostile fluid.");
			else if (DamageType == 'Mortared')
				BroadcastMessage(Other.GetHumanName()@" was blown up by a mortar.");
			else if (DamageType == 'Drowned')
				BroadcastMessage(Other.GetHumanName()@" forgot to come up for air.");
			else if (DamageType == 'Fell')
				BroadcastMessage(Other.GetHumanName()@" crashed falling.");
			else if (DamageType == 'Eradicated')
				BroadcastMessage(Other.GetHumanName()@" has been eradicated.");
			else if (DamageType == 'Suicided')						//Can be ? Movers ? Others ?
				BroadcastMessage(Other.GetHumanName()@" suffered a self damage.");
			else if (DamageType == 'Crushed')
				BroadcastMessage(Other.GetHumanName()@" died crushed.");
			else
				BroadcastMessage(Other.GetHumanName()@" died.");
			if ( ScriptedPawn(Other) != None && ScriptedPawn(Other).CarcassType != None )
				ScriptedPawn(Other).SpawnGibbedCarcass();
			Other.Destroy(); //Done
			return;
		}
		if ( Other.PlayerReplicationInfo != None && DamageType == 'SpecialDamage')
		{
			if (SpecialDamageString == "")
				BroadcastMessage(Other.GetHumanName()@"died.");
			else
				BroadcastMessage(Other.GetHumanName()@"died"@SpecialDamageString);
			Other.DieCount++;
			Other.PlayerReplicationInfo.Score -= 1;
			Other.Spree = 0;
			return;
		}
		if (Other == None) return;
	}
	Super(GameInfo).Killed(killer, Other, damageType); //Now do call if need something
}

function ScoreKill(pawn Killer, pawn Other)
{
	local TournamentPlayer TP;

	Other.DieCount++;
	if ( (Killer == Other || Killer == None) && Other.PlayerReplicationInfo != None )
		Other.PlayerReplicationInfo.Score -= 1;
	else if ( Killer != None )
	{
		Killer.KillCount++;
		if ( bAltScoring && (Killer != Other) && Other.PlayerReplicationInfo != None ) //DeathMatchPlus.ScoreKill Accesed None ??? No wander...
			Other.PlayerReplicationInfo.Score -= 1;

		if ( Killer.bIsPlayer && Killer.PlayerReplicationInfo != None )
		{
			if (Killer.IsA('TournamentPlayer') && (!Other.bIsPlayer || Other.PlayerReplicationInfo == None))
			{
				TP = TournamentPlayer(Killer);
				if ( TP.Level.TimeSeconds - TP.LastKillTime < 3 )
				{
					TP.MultiLevel++;
					TP.ReceiveLocalizedMessage( class'MultiKillMessage', TP.MultiLevel );
				} 
				else
					TP.MultiLevel = 0;
				TP.LastKillTime = TP.Level.TimeSeconds;
			}
			if ( Other != None && (!Other.bIsPlayer || Other.PlayerReplicationInfo == None) )
				BroadcastMessage(Killer.GetHumanName()@"killed "$Other.GetHumanName());
		}

		if ( Killer.PlayerReplicationInfo == None && Other.PlayerReplicationInfo == None && Killer != Other )
			BroadcastMessage(Killer.GetHumanName()@"killed "$Other.GetHumanName());

		if ((!Killer.bIsPlayer || Killer.PlayerReplicationInfo == None) && (Other.bIsPlayer || Other.PlayerReplicationInfo != None))
			Other.PlayerReplicationInfo.Score -= 1;

		if ( Killer == Other && ( !Killer.bIsPlayer || Killer.PlayerReplicationInfo == None ) )
			BroadcastMessage(Killer.GetHumanName()@"suffered a self deadly pain.");
	}
	BaseMutator.ScoreKill(Killer, Other); //LOL
}

function ChangeName(Pawn Other, string S, bool bNameChange)
{
	local pawn APlayer;
	S = left(S,24);
	if (Other.PlayerReplicationInfo.PlayerName~=S)
		return;
	Super(GameInfo).ChangeName(Other, S, bNameChange);
}

function PlayStartUpMessage(PlayerPawn NewPlayer)
{
	local int i;

	NewPlayer.ClearProgressMessages();
	// Game Name
	NewPlayer.SetProgressMessage(GameName, i++);
	// Optional FragLimit
	if ( fraglimit > 0 )
		NewPlayer.SetProgressMessage(FragLimit@GameGoal, i++);
/*
	if ( Level.NetMode == NM_Standalone )
		NewPlayer.SetProgressMessage(SingleWaitingMessage, i++);
	else if ( bRequireReady )
		NewPlayer.SetProgressMessage(TourneyMessage, i++);
*/
}

event PostLogin( playerpawn NewPlayer )
{
	Super.PostLogin(NewPlayer);
	BroadcastMessage(NewPlayer.GetHumanName()$" joined to the party.");
}

function Logout(pawn Exiting)
{
	local Projectile Pr;

	foreach Exiting.VisibleCollidingActors (class 'Projectile',Pr,Exiting.Default.SightRadius*2)
	{
		if ( Pr != None && Pr.Instigator == Exiting )
		{
			Pr.bReplicateInstigator = False;
			Pr.Instigator = None;
			Pr.Destroy();
		}
	}
	if ( !Exiting.bIsPlayer || Exiting.PlayerReplicationInfo == None )
		return;
	Super.Logout(Exiting);
}

function bool SetEndCams(string Reason)
{
	local pawn P, Best;
	local PlayerPawn Player;

	// find individual winner
	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		if (!P.bIsPlayer || P.PlayerReplicationInfo == None)
			continue;
		if ( P.bIsPlayer && !P.IsA('Spectator') && ((Best == None) || ( P.PlayerReplicationInfo.Score > Best.PlayerReplicationInfo.Score )) )
			Best = P;
	}
	if ( ((NumPlayers + NumBots) < 2) && ( Best != None && Best.PlayerReplicationInfo.Score == 0 ) )
	{
		BroadcastLocalizedMessage( DMMessageClass, 0 );
		return false;
	}
	// check for tie
	if ( Best != None )
	{
		for ( P=Level.PawnList; P!=None; P=P.nextPawn )
			if ( P.bIsPlayer && (Best != P) && ( P.PlayerReplicationInfo.Score == Best.PlayerReplicationInfo.Score ))
			{
				BroadcastLocalizedMessage( DMMessageClass, 0 );
				return false;
			}
	}
	EndTime = Level.TimeSeconds + 3.0;
	if ( Best != None && Best.PlayerReplicationInfo.Score > 0)
		GameReplicationInfo.GameEndedComments = Best.PlayerReplicationInfo.PlayerName@GameEndedMessage;
	log( "Game ended at "$EndTime);
	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		Player = PlayerPawn(P);
		if ( Player != None )
		{
			if (!bTutorialGame)
			if ( Best != None  )
			{
				if ( Best.PlayerReplicationInfo.Score < 1 )
					Best = None; //Negative score is not a Victory, neither 0 score as above
				PlayWinMessage(Player, (Player == Best)); //won't play winning msg for sure
			}
			Player.bBehindView = true;
			if ( Best != None )
			{
				if ( Player == Best )
					Player.ViewTarget = None;
				else
					Player.ViewTarget = Best;
			}
			else
				Player.ViewTarget = None;
			Player.ClientGameEnded();
		}
		P.GotoState('GameEnded');
	}
	CalcEndStats();
	return true;
}

function AddDefaultInventory( pawn PlayerPawn )
{
	local Weapon NewWeapon;
	local Bot B;

	if ( PlayerPawn.IsA('Spectator') || (bRequireReady && (CountDown > 0)) )
		return;

	Super(GameInfo).AddDefaultInventory(PlayerPawn);

	if ( bUseTranslocator && (!bRatedGame || bRatedTranslocator) )
	{
		// Spawn Translocator.
		if( PlayerPawn.FindInventoryType(class'CTFTranslocator')==None )
		{
			newWeapon = Spawn(class'CTFTranslocator');
			if( newWeapon != None )
			{
				newWeapon.Instigator = PlayerPawn;
				newWeapon.BecomeItem();
				PlayerPawn.AddInventory(newWeapon);
				newWeapon.GiveAmmo(PlayerPawn);
				newWeapon.SetSwitchPriority(PlayerPawn);
				newWeapon.WeaponSet(PlayerPawn);
			}
		}
	}
	// Spawn Automag
	// Nelsona: What AutoMag ?
	GiveWeapon(PlayerPawn, "UnrealShare.DispersionPistol"); //Better a regeneration one - monsters are firing in infinity

	B = Bot(PlayerPawn);
	if ( B != None )
		B.bHasImpactHammer = (B.FindInventoryType(class'ImpactHammer') != None);
}

function CalcEndStats()
{
//	When you are shouting as retard be sure I'll remove uninteresting craps because I love silence.
//	That one should be configurable...
	log ("We suppose to calculate farts... oops stats ?");
// To do wepsy rotation restoration here if needs... will checkout
}

function DiscardInventory( Pawn Other ) //Guess why I did a... small look around
{
	local actor dropped;
	local inventory Inv;
	local weapon weap;
	local float speed;

	CaptureActor(CaptActor).bHaveASpawn=True; //This has been called - look out how we replace stuff dropped in Base_Mute
	if( Other.DropWhenKilled != None )
	{
		dropped = Spawn(Other.DropWhenKilled,,,Other.Location); //Break in here if replacement works - next lines won't act anymore
		Inv = Inventory(dropped);
		if ( Inv != None )
		{
			Inv.RespawnTime = 0.0; //don't respawn - Nelsona: For sure not even replacements - except from decorations... RIGHT ???
			Inv.BecomePickup();
		}
		if ( dropped != None )
		{
			dropped.RemoteRole = ROLE_DumbProxy;
			dropped.SetPhysics(PHYS_Falling);
			dropped.bCollideWorld = true;
			dropped.Velocity = Other.Velocity + VRand() * 280;
		}
		if ( Inv != None )
			Inv.GotoState('PickUp', 'Dropped');
	}
	if( (Other.Weapon!=None) && (Other.Weapon.Class!=Level.Game.BaseMutator.MutatedDefaultWeapon()) 
		&& Other.Weapon.bCanThrow )
	{
		speed = VSize(Other.Velocity);
		weap = Other.Weapon;
		if (speed != 0)
			weap.Velocity = Normal(Other.Velocity/speed + 0.5 * VRand()) * (speed + 280);
		else {
			weap.Velocity.X = 0;
			weap.Velocity.Y = 0;
			weap.Velocity.Z = 0;
		}
		Other.TossWeapon();
		if ( weap.PickupAmmoCount == 0 )
			weap.PickupAmmoCount = 1;
	}
	Other.Weapon = None;
	Other.SelectedItem = None;
	for( Inv=Other.Inventory; Inv!=None; Inv=Inv.Inventory )
		Inv.Destroy();
	CaptureActor(CaptActor).bHaveASpawn=False; //End, prepare to next one
}

defaultproperties
{
     ExplodeMessage=" was directly blown up"
     FallMessage=" left just a small crater."
     DrownedMessage=" has drowned because of missing air."
     BurnedMessage=" was so incinerated"
     CorrodedMessage=" was nasty slimed"
     HackedMessage=" was successfully hacked"
     MortarMessage=" was blasted by a mortar."
     GameName="DeathMatch NS version"
     MutatorClass=Class'NsDM3.NsDeathMatchMutator'
     StatLogClass=Class'NsDM3.DMLogFile'
}